package scheme.absyn;

import scheme.interp.*;
import scheme.util.EmptyListE;

public class EmptyExpL extends ExpList {

    public void accept (ExpListVisitor v) throws VisitE {
        v.visitEmptyExpL(this);
    }

    public Exp hd () { throw new EmptyListE(); }

    public ExpList tl () { throw new EmptyListE(); }

    public ExpList snoc (Exp last) {
        return new ConsE(last,this);
    }
}

