package scheme.interp;

import scheme.absyn.ConstantE;
import scheme.absyn.QuoteE;
import scheme.absyn.VarE;
import scheme.absyn.SetE;
import scheme.absyn.IfE;
import scheme.absyn.BeginE;
import scheme.absyn.LetE;
import scheme.absyn.PrimappE;
import scheme.absyn.LetrecE;
import scheme.absyn.LambdaE;
import scheme.absyn.AppE;

public interface ExpVisitor {
    void visitConstantE (ConstantE e) throws VisitE;
    void visitQuoteE (QuoteE e) throws VisitE;
    void visitVarE (VarE e) throws VisitE;
    void visitSetE (SetE e) throws VisitE;
    void visitIfE (IfE e) throws VisitE;
    void visitBeginE (BeginE e) throws VisitE;
    void visitLetE (LetE e) throws VisitE;
    void visitPrimappE (PrimappE e) throws VisitE;
    void visitLetrecE (LetrecE e) throws VisitE;
    void visitLambdaE (LambdaE e) throws VisitE;
    void visitAppE (AppE e) throws VisitE;
}
