package scheme.absyn;

import scheme.interp.*;

public abstract class ExpList {

    public ExpList cons (Exp hd) {
        return new ConsE(hd,this);
    }

    public abstract void accept (ExpListVisitor v) throws VisitE;

    public abstract Exp hd ();

    public abstract ExpList tl ();

    public abstract ExpList snoc (Exp last);

}    
