package scheme.absyn;

public class IfE extends Exp {
    private Exp testExp;
    private Exp thenExp;
    private Exp elseExp;

    public IfE (Exp testExp, Exp thenExp, Exp elseExp) {
        this.testExp = testExp;
        this.thenExp = thenExp;
        this.elseExp = elseExp;
    }

    public Exp getTest() { return testExp; }

    public Exp getThen() { return thenExp; }

    public Exp getElse() { return elseExp; }

    public void accept (scheme.interp.ExpVisitor v) throws scheme.interp.VisitE {
        v.visitIfE(this);
    }
}
