package scheme.interp;

import scheme.absyn.*;
import scheme.util.*;

public class Eval_ExpList implements ExpListVisitor {
    private List vals;
    private Eval_Exp eval_exp;

    public Eval_ExpList (Eval_Exp eval_exp) {
        this.eval_exp = eval_exp;
    }

    public List getValues () { return vals; }

    public void visitEmptyExpL (EmptyExpL e) throws VisitE {
        vals = new EmptyL();
    }

    public void visitConsE (ConsE e) throws VisitE {
        Exp hd = e.hd();
        ExpList tl = e.tl();
        hd.accept(eval_exp);
        SchemeValue hdv = eval_exp.getValue();
        tl.accept(this);
        vals = new Cons(hdv,vals);
    }
}
