package scheme.interp;

import scheme.util.List;

public abstract class SchemeValue {
    public boolean isTrue () { return true; }
    public SchemeValue apply (List argVs, Eval_Exp eval_exp) throws VisitE {
        throw new VisitE(this + " is not a function");
    }
    public int getInt () throws VisitE { 
        throw new VisitE(this + " is not an int"); 
    }
    public SchemeValue getCar () throws VisitE {
        throw new VisitE(this + " is not a pair"); 
    }
    public SchemeValue getCdr () throws VisitE {
        throw new VisitE(this + " is not a pair"); 
    }
    public void setCar (SchemeValue v) throws VisitE {
        throw new VisitE(this + " is not a pair"); 
    }
    public void setCdr (SchemeValue v) throws VisitE {
        throw new VisitE(this + " is not a pair"); 
    }
}
